{{

+------------------------------------------+
 TV_Text_Half_Height V1.0                 
 Copyright (c) 2006 Parallax, Inc.                       
 See end of file for terms of use.                        
+------------------------------------------+

This is basically Parallax's TV_Text.spin but with a few minor changes by me ( Jim Bagley ) , in setup, to allow not only pin setup, but PAL/NTSC mode, and Tile Width and Height.

added interlace variable in start
added PAL forcing HX to 5 instead of 4 for displays =<40 width
added ink(PEN)   to save having to do out($0c) and out(pen)
added inkblock(X,Y,W,H,PEN) which sets attributes on screen starting at X,Y and width W, height H, setting text in that area to be colour PEN  

}}

'*****************************
'*  TV Text 40x30 v1.3       *
'*  (C) 2009 Parallax, Inc.  *
'*****************************

CON

tv_count = 14

MAXCOLS = 40 ' this is to get a max screen buffer, as it can't be allocated and deallocated on the fly.
MAXROWS = 30 ' this is to get a max screen buffer, as it can't be allocated and deallocated on the fly.
'MAXCOLS_PAL = 54 ' you can change hx to 6
'MAXROWS_PAL = 35
'MAXCOLS_NTSC = 44
'MAXROWS_NTSC = 30
  
VAR

  long  col, row, color, flag
  
  word  screen[MAXCOLS * MAXROWS]
  long  colors[8 * 2]

  long  tv_status     '0/1/2 = off/invisible/visible              read-only   (14 longs)
  long  tv_enable     '0/non-0 = off/on                           write-only
  long  tv_pins       '%pppmmmm = pin group, pin group mode       write-only
  long  tv_mode       '%tccip = tile,chroma,interlace,ntsc/pal    write-only
  long  tv_screen     'pointer to screen (words)                  write-only      
  long  tv_colors     'pointer to colors (longs)                  write-only                            
  long  tv_ht         'horizontal tiles                           write-only                            
  long  tv_vt         'vertical tiles                             write-only                            
  long  tv_hx         'horizontal tile expansion                  write-only                            
  long  tv_vx         'vertical tile expansion                    write-only                            
  long  tv_ho         'horizontal offset                          write-only                            
  long  tv_vo         'vertical offset                            write-only                            
  long  tv_broadcast  'broadcast frequency (Hz)                   write-only                            
  long  tv_auralcog   'aural fm cog                               write-only                            

  word  cols
  word  rows

  word  screensize
  word  lastrow

OBJ

  tv : "tvhalf"


PUB start(basepin,ntscpal,interlaced,width,height) : okay

' Start terminal - starts a cog
' returns false if no cog available

  if width>MAXCOLS
    width:=MAXCOLS
  if height>MAXROWS
    height:=MAXROWS
  tvparams_pins := (basepin & $38) << 1 | (basepin & 4 == 4) & %0101 'Neu
  tv_params[3]:=%10000+((interlaced&1)<<1)+(ntscpal&1) 'set PAL or NTSC ( this also sets 16x16 full size tile, and interlaced )
  tv_params[6]:=width 'set cols
  tv_params[7]:=height 'sets rows
  tv_params[8]:=4
  if(ntscpal and width=<40)
    tv_params[8]:=5
  cols := width
  rows := height
  screensize := cols * rows
  lastrow := screensize - cols

  setcolors(@palette)
  out(0)
  
  longmove(@tv_status, @tv_params, tv_count)
  tv_pins := (basepin & $38) << 1 | (basepin & 4 == 4) & %0101
  tv_screen := @screen
  tv_colors := @colors
  
  okay := tv.start(@tv_status)

PUB GetADR
  return @screen

PUB stop

' Stop terminal - frees a cog

  tv.stop


PUB str(stringptr)

' Print a zero-terminated string

  repeat strsize(stringptr)
    out(byte[stringptr++])


PUB dec(value) | i

' Print a decimal number

  if value < 0
    -value
    out("-")

  i := 1_000_000_000

  repeat 10
    if value => i
      out(value / i + "0")
      value //= i
      result~~
    elseif result or i == 1
      out("0")
    i /= 10


PUB hex(value, digits)

' Print a hexadecimal number

  value <<= (8 - digits) << 2
  repeat digits
    out(lookupz((value <-= 4) & $F : "0".."9", "A".."F"))


PUB bin(value, digits)

' Print a binary number

  value <<= 32 - digits
  repeat digits
    out((value <-= 1) & 1 + "0")


PUB out(c) | i, k

' Output a character
'
'     $00 = clear screen
'     $01 = home
'     $08 = backspace
'     $09 = tab (8 spaces per)
'     $0A = set X position (X follows)
'     $0B = set Y position (Y follows)
'     $0C = set color (color follows)
'     $0D = return
'  others = printable characters

  case flag
    $00: case c
           $00: wordfill(@screen, $220, screensize)
                col := row := 0
           $01: col := row := 0
           $08: if col
                  col--
           $09: repeat
                  print(" ")
                while col & 7
           $0A..$0C: flag := c
                     return
           $0D: newline
           other: print(c)
    $0A: col := c // cols
    $0B: row := c // rows
    $0C: color := c & 7
  flag := 0

PUB ink(pen)
  color := pen&7

PUB inkblock(x,y,w,h,pen) | x1,y1
  repeat y1 from y to y+h-1
    repeat x1 from x to x+w-1
      screen[y1*cols+x1]:=screen[y1*cols+x1]&$7ff + ((pen&7)<<11)
  
PUB setcolors(colorptr) | i, fore, back

' Override default color palette
' colorptr must point to a list of up to 8 colors
' arranged as follows:
'
'               fore   back
'               ------------
' palette  byte color, color     'color 0
'          byte color, color     'color 1
'          byte color, color     'color 2
'          ...

  repeat i from 0 to 7
    fore := byte[colorptr][i << 1]
    back := byte[colorptr][i << 1 + 1]
    colors[i << 1]     := fore << 24 + back << 16 + fore << 8 + back
    colors[i << 1 + 1] := fore << 24 + fore << 16 + back << 8 + back

PUB setcolour(colorptr)
  colors[0]:=long[colorptr][0]
  colors[1]:=long[colorptr][1]

PUB printNoAdvance(c) ' mpark
  screen[row * cols + col] := (color << 1 + c & 1) << 10 + $200 + c & $FE

PUB SetXY( x, y ) ' mpark
  col := x
  row := y
  
PUB SetX( x ) ' mpark
  col := x

PUB SetY( y ) ' mpark
  row := y

PUB print(c)

  screen[row * cols + col] := (color << 1 + c & 1) << 10 + $200 + c & $FE
  if ++col == cols
    newline


PRI newline | i

  col := 0
  if ++row == rows
    row--
    wordmove(@screen, @screen[cols], lastrow)   'scroll lines
    wordfill(@screen[lastrow], $220, cols)      'clear new line

PUB VSync
  repeat while tv_status<>1
  repeat while tv_status==1

DAT

tv_params               long    0               'status
                        long    1               'enable
tvparams_pins           long    %001_0101 '0               'pins
                        long    %0' %10111 '%10010          'mode
                        long    0               'screen
                        long    0               'colors
                        long    40              'hc
                        long    30              'vc
                        long    4               'hx
                        long    1               'vx
                        long    0               'ho
                        long    0               'vo
                        long    0               'broadcast
                        long    0               'auralcog


                        '       fore   back
                        '       color  color
palette                 byte    $07,   $0A    '0    white / dark blue
                        byte    $07,   $BB    '1    white / red
                        byte    $9E,   $9B    '2   yellow / brown
                        byte    $04,   $07    '3     grey / white
                        byte    $3D,   $3B    '4     cyan / dark cyan
                        byte    $6B,   $6E    '5    green / gray-green
                        byte    $BB,   $CE    '6      red / pink
                        byte    $3C,   $0A    '7     cyan / blue

{{
+------------------------------------------------------------------------------------------------------------------------------+
                                                   TERMS OF USE: MIT License                                                                                                              
+------------------------------------------------------------------------------------------------------------------------------
Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation     
files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    
modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software
is furnished to do so, subject to the following conditions:                                                                   
                                                                                                                              
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
                                                                                                                              
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          
WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         
+------------------------------------------------------------------------------------------------------------------------------+
}}                         
